import React from 'react';
import { _PixPhotoProcessorAction, PhotoProcessorStep, PixPhotoProcessorStateProps, TemplateImage } from './types';
import { ProcessImagesPayload } from './types';
import { Job } from './types';
declare const PixPhotoProcessorProvider: ({ children }: {
    children: React.ReactNode;
}) => JSX.Element;
declare const usePixPhotoProcessorState: () => PixPhotoProcessorStateProps;
declare const usePixPhotoProcessorDispatch: () => React.Dispatch<_PixPhotoProcessorAction>;
declare const usePixPhotoProcessorFunctions: () => {
    changeImageSource: (batchIndex: number, imageId: string) => void;
    setReducer: (len: number) => void;
    goToPreviousStep: (step: PhotoProcessorStep) => void;
    goToProcessImages: (payload: ProcessImagesPayload, batchIndex: number) => void;
    goToGallery: (processedJob: Job, batchIndex: any) => void;
    handleError: (step: PhotoProcessorStep, description: string, batchIndex: number) => void;
    goToComposite: () => void;
    setCompositeData: (rawImages: TemplateImage[] | undefined, batchIndex: number) => any[];
    unselectCompositeImage: (imageId: string, batchIndex: number) => void;
    selectCompositeImage: (imageId: string, row: number, col: number, batchIndex: number) => void;
};
declare const usePixPhotoProcessor: () => (PixPhotoProcessorStateProps | React.Dispatch<_PixPhotoProcessorAction>)[];
export { PixPhotoProcessorProvider, usePixPhotoProcessor, usePixPhotoProcessorState, usePixPhotoProcessorDispatch, usePixPhotoProcessorFunctions, };
