Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var reactDnd = require('react-dnd');
var react = require('@chakra-ui/react');
var reactRange = require('react-range');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

/** @deprecated */
function __spreadArrays() {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
}

var useSafeContext = function (newContext, contextName) {
    var context = React.useContext(newContext);
    if (!context) {
        throw new Error(contextName + " hooks must be used within a " + contextName + " Provider");
    }
    return context;
};

exports.Gender = void 0;
(function (Gender) {
    Gender["MALE"] = "MALE";
    Gender["FEMALE"] = "FEMALE";
})(exports.Gender || (exports.Gender = {}));
exports.SubscriptionPlanStateEnum = void 0;
(function (SubscriptionPlanStateEnum) {
    SubscriptionPlanStateEnum["NONE"] = "NONE";
    SubscriptionPlanStateEnum["ONBOARDING"] = "ONBOARDING";
    SubscriptionPlanStateEnum["TRIAL"] = "TRIAL";
    SubscriptionPlanStateEnum["PAYMENT_PENDING"] = "PAYMENT_PENDING";
    SubscriptionPlanStateEnum["ACTIVE"] = "ACTIVE";
    SubscriptionPlanStateEnum["ACTIVE_WILL_EXPIRE"] = "ACTIVE_WILL_EXPIRE";
    SubscriptionPlanStateEnum["ACTIVE_WILL_DOWNGRADE"] = "ACTIVE_WILL_DOWNGRADE";
})(exports.SubscriptionPlanStateEnum || (exports.SubscriptionPlanStateEnum = {}));
exports.SubscriptionPlanEnum = void 0;
(function (SubscriptionPlanEnum) {
    SubscriptionPlanEnum["FREE"] = "FREE";
    SubscriptionPlanEnum["SOLO_MONTHLY"] = "SOLO_MONTHLY";
    SubscriptionPlanEnum["CABINET_MONTHLY"] = "CABINET_MONTHLY";
})(exports.SubscriptionPlanEnum || (exports.SubscriptionPlanEnum = {}));
exports.SubscriptionPlanProductEnum = void 0;
(function (SubscriptionPlanProductEnum) {
    SubscriptionPlanProductEnum["FREE"] = "FREE";
    SubscriptionPlanProductEnum["BASIC"] = "BASIC";
    SubscriptionPlanProductEnum["UNLIMITED"] = "UNLIMITED";
    SubscriptionPlanProductEnum["NONE"] = "NONE";
})(exports.SubscriptionPlanProductEnum || (exports.SubscriptionPlanProductEnum = {}));
exports.FaceZoomLevel = void 0;
(function (FaceZoomLevel) {
    FaceZoomLevel["LOW"] = "LOW";
    FaceZoomLevel["MEDIUM"] = "MEDIUM";
})(exports.FaceZoomLevel || (exports.FaceZoomLevel = {}));
exports.OcclusalCut = void 0;
(function (OcclusalCut) {
    OcclusalCut["SIX"] = "SIX";
    OcclusalCut["SEVEN"] = "SEVEN";
})(exports.OcclusalCut || (exports.OcclusalCut = {}));
exports.IntraOralZoomLevel = void 0;
(function (IntraOralZoomLevel) {
    IntraOralZoomLevel["LEVEL_85P"] = "LEVEL_85P";
    IntraOralZoomLevel["LEVEL_95P"] = "LEVEL_95P";
})(exports.IntraOralZoomLevel || (exports.IntraOralZoomLevel = {}));
exports.ImageTypeEnum = void 0;
(function (ImageTypeEnum) {
    ImageTypeEnum["INTRA_ORALE_FRONTALE"] = "INTRA_ORALE_FRONTALE";
    ImageTypeEnum["INTRA_ORALE_GAUCHE"] = "INTRA_ORALE_GAUCHE";
    ImageTypeEnum["INTRA_ORALE_DROITE"] = "INTRA_ORALE_DROITE";
    ImageTypeEnum["OCCLUSALE_INFERIEURE"] = "OCCLUSALE_INFERIEURE";
    ImageTypeEnum["OCCLUSALE_SUPERIEURE"] = "OCCLUSALE_SUPERIEURE";
    ImageTypeEnum["VISAGE_FRONTAL_SANS_SOURIRE"] = "VISAGE_FRONTAL_SANS_SOURIRE";
    ImageTypeEnum["VISAGE_PROFIL_DROITE"] = "VISAGE_PROFIL_DROITE";
    ImageTypeEnum["VISAGE_FRONTAL_AVEC_SOURIRE"] = "VISAGE_FRONTAL_AVEC_SOURIRE";
    ImageTypeEnum["VISAGE_TROIS_QUARTS"] = "VISAGE_TROIS_QUARTS";
    ImageTypeEnum["AUTRE"] = "AUTRE";
    ImageTypeEnum["VISAGE_FRONTAL_DESSOUS"] = "VISAGE_FRONTAL_DESSOUS";
})(exports.ImageTypeEnum || (exports.ImageTypeEnum = {}));
exports.PixPhotoProcessorActionType = void 0;
(function (PixPhotoProcessorActionType) {
    PixPhotoProcessorActionType["CANCEL_EDIT_IMAGES"] = "CANCEL_EDIT_IMAGES";
    PixPhotoProcessorActionType["SAVE_EDIT_IMAGES"] = "SAVE_EDIT_IMAGES";
    PixPhotoProcessorActionType["SWITCH_EDIT_IMAGE"] = "SWITCH_EDIT_IMAGE";
    PixPhotoProcessorActionType["CHANGE_SOURCE"] = "CHANGE_SOURCE";
    PixPhotoProcessorActionType["SET_REDUCER"] = "SET_REDUCER";
    PixPhotoProcessorActionType["SET_EDITOR_STATE"] = "SET_EDITOR_ON";
    PixPhotoProcessorActionType["SET_STEP"] = "SET_STEP";
    PixPhotoProcessorActionType["SET_PE_PROCESSING"] = "SET_PE_PROCESSING";
    PixPhotoProcessorActionType["SET_PE_GALLERY"] = "SET_PE_GALLERY";
    PixPhotoProcessorActionType["SET_PE_COMPOSITE"] = "SET_PE_COMPOSITE";
    PixPhotoProcessorActionType["RESET_PHOTO_PROCESSOR"] = "RESET_PHOTO_PROCESSOR";
    PixPhotoProcessorActionType["SET_COMPOSITE_INITIALIZED"] = "SET_COMPOSITE_INITIALIZED";
    PixPhotoProcessorActionType["SET_COMPOSITE_IMAGE_LIST"] = "SET_COMPOSITE_IMAGE_LIST";
    PixPhotoProcessorActionType["SET_COMPOSITE_LOADING"] = "SET_COMPOSITE_LOADING";
    PixPhotoProcessorActionType["SELECT_COMPOSITE_IMAGE"] = "SELECT_COMPOSITE_IMAGE";
    PixPhotoProcessorActionType["UNSELECT_COMPOSITE_IMAGE"] = "UNSELECT_COMPOSITE_IMAGE";
    PixPhotoProcessorActionType["SET_COMPOSITE_LOGO_SOURCE"] = "SET_COMPOSITE_LOGO_SOURCE";
    PixPhotoProcessorActionType["REPLACE_COMPOSITE_IMAGE"] = "REPLACE_COMPOSITE_IMAGE";
    PixPhotoProcessorActionType["START_EDIT_IMAGE"] = "START_EDIT_IMAGE";
    PixPhotoProcessorActionType["CANCEL_EDIT_IMAGE"] = "CANCEL_EDIT_IMAGE";
    PixPhotoProcessorActionType["FINISH_EDIT_IMAGE"] = "FINISH_EDIT_IMAGE";
    PixPhotoProcessorActionType["SET_JOB_STATUT"] = "SET_JOB_STATUT";
    PixPhotoProcessorActionType["SET_JOB_PROGRESS"] = "SET_JOB_PROGRESS";
    PixPhotoProcessorActionType["SET_TEMPLATE_STATUS"] = "SET_TEMPLATE_STATUS";
    PixPhotoProcessorActionType["TRIGGER_DOWNLOAD"] = "TRIGGER_DOWNLOAD";
    PixPhotoProcessorActionType["RESET_DOWNLOAD_COUNTER"] = "RESET_DOWNLOAD_COUNTER";
    PixPhotoProcessorActionType["UPDATE_PROCESSED_IMAGE_URL"] = "UPDATE_PROCESSED_IMAGE_URL";
    PixPhotoProcessorActionType["UPDATE_TEMPLATE_ZIP_URL"] = "UPDATE_TEMPLATE_ZIP_URL";
    PixPhotoProcessorActionType["SWAP_JOB"] = "SWAP_JOB";
})(exports.PixPhotoProcessorActionType || (exports.PixPhotoProcessorActionType = {}));
exports.PhotoProcessorStep = void 0;
(function (PhotoProcessorStep) {
    PhotoProcessorStep[PhotoProcessorStep["WAITING_FOR_FILES"] = 0] = "WAITING_FOR_FILES";
    PhotoProcessorStep[PhotoProcessorStep["PROCESSING"] = 1] = "PROCESSING";
    PhotoProcessorStep[PhotoProcessorStep["GALLERY"] = 2] = "GALLERY";
    PhotoProcessorStep[PhotoProcessorStep["COMPOSITE"] = 3] = "COMPOSITE";
})(exports.PhotoProcessorStep || (exports.PhotoProcessorStep = {}));
exports.JOB_STATUTES = void 0;
(function (JOB_STATUTES) {
    JOB_STATUTES["IDLE"] = "IDLE";
    JOB_STATUTES["PREPARING"] = "PREPARING";
    JOB_STATUTES["UPLOADING"] = "UPLOADING";
    JOB_STATUTES["PROCESSING"] = "PROCESSING";
    JOB_STATUTES["SUCCESS"] = "SUCCESS";
    JOB_STATUTES["FAILURE"] = "FAILURE";
})(exports.JOB_STATUTES || (exports.JOB_STATUTES = {}));
exports.TEMPLATE_STATUTES = void 0;
(function (TEMPLATE_STATUTES) {
    TEMPLATE_STATUTES["IDLE"] = "IDLE";
    TEMPLATE_STATUTES["UPLOADING"] = "UPLOADING";
    TEMPLATE_STATUTES["SUCCESS"] = "SUCCESS";
    TEMPLATE_STATUTES["FAILURE"] = "FAILURE";
})(exports.TEMPLATE_STATUTES || (exports.TEMPLATE_STATUTES = {}));
exports.IMAGE_TYPES = void 0;
(function (IMAGE_TYPES) {
    IMAGE_TYPES["TOP_LEFT"] = "VISAGE_FRONTAL_SANS_SOURIRE";
    IMAGE_TYPES["TOP_MIDDLE"] = "VISAGE_FRONTAL_AVEC_SOURIRE";
    IMAGE_TYPES["TOP_RIGHT"] = "VISAGE_PROFIL_DROITE";
    IMAGE_TYPES["MIDDLE_LEFT"] = "OCCLUSALE_SUPERIEURE";
    IMAGE_TYPES["MIDDLE_RIGHT"] = "OCCLUSALE_INFERIEURE";
    IMAGE_TYPES["BOTTOM_LEFT"] = "INTRA_ORALE_DROITE";
    IMAGE_TYPES["BOTTOM_MIDDLE"] = "INTRA_ORALE_FRONTALE";
    IMAGE_TYPES["BOTTOM_RIGHT"] = "INTRA_ORALE_GAUCHE";
})(exports.IMAGE_TYPES || (exports.IMAGE_TYPES = {}));

var proxy_url = "https://oralpix.com:8080";
var convertS3Url = function (url) {
    var proxyUrlPrefix = (proxy_url ) + "/__proxy?path=";
    if (!url || typeof url !== "string") {
        return url;
    }
    var isReserved = ["blob:", "data:", proxyUrlPrefix].some(function (prefix) { return url.startsWith(prefix); });
    return isReserved ? url : url; //proxyUrlPrefix + encodeURIComponent(url);
};
var generateTemplateData = function (jobData) {
    var _a;
    var inputImageMap = new Map((_a = jobData.inputImages) === null || _a === void 0 ? void 0 : _a.map(function (image) { return [
        image.id,
        { url: image.url, name: image.filename },
    ]; }));
    return jobData.processedImages.map(function (processedImage) {
        var _a, _b, _c, _d;
        var originalUrl = convertS3Url((_b = (_a = inputImageMap.get(processedImage.idOriginalImage)) === null || _a === void 0 ? void 0 : _a.url) !== null && _b !== void 0 ? _b : "");
        var url = processedImage.url ? convertS3Url(processedImage.url) : originalUrl;
        return {
            id: processedImage.id,
            type: processedImage.type,
            filename: (_d = (_c = inputImageMap.get(processedImage.idOriginalImage)) === null || _c === void 0 ? void 0 : _c.name) !== null && _d !== void 0 ? _d : "",
            url: url,
            originalUrl: originalUrl,
        };
    });
};
function getImageFromSource(source) {
    return new Promise(function (resolve, reject) {
        var img = new Image();
        img.onload = function () { return resolve(img); };
        img.onerror = function (error) { console.log(error); };
        img.crossOrigin = "anonymous";
        img.src = source;
    });
}
function addImageParams(imageObject) {
    return getImageFromSource(imageObject.src).then(function (image) {
        var naturalHeight = image.naturalHeight, naturalWidth = image.naturalWidth;
        return __assign(__assign({}, imageObject), { naturalWidth: image === null || image === void 0 ? void 0 : image.naturalWidth, naturalHeight: naturalHeight, aspectRatio: naturalHeight / naturalWidth });
    });
}
function convertImage(image) {
    return {
        id: image.id,
        type: image.type,
        filename: image.filename,
        status: "UNSELECTED",
        src: image.url,
        editorSrc: image.url,
        processedSrc: image.url,
        originalSrc: image.originalUrl,
        editParams: undefined,
        initEditParams: undefined,
        position: {},
        aspectRatio: undefined,
        naturalWidth: 0,
        naturalHeight: 0,
        isOriginal: false,
    };
}
var positionMap = {
    TOP: 1,
    MIDDLE: 2,
    BOTTOM: 3,
    LEFT: 1,
    RIGHT: 3,
};
var INVERSE_IMAGE_TYPES = {
    VISAGE_FRONTAL_SANS_SOURIRE: "TOP_LEFT",
    VISAGE_FRONTAL_AVEC_SOURIRE: "TOP_MIDDLE",
    VISAGE_PROFIL_DROITE: "TOP_RIGHT",
    OCCLUSALE_SUPERIEURE: "MIDDLE_LEFT",
    OCCLUSALE_INFERIEURE: "MIDDLE_RIGHT",
    INTRA_ORALE_DROITE: "BOTTOM_LEFT",
    INTRA_ORALE_FRONTALE: "BOTTOM_MIDDLE",
    INTRA_ORALE_GAUCHE: "BOTTOM_RIGHT",
};
function getColumn(imageType) {
    var position = INVERSE_IMAGE_TYPES[imageType];
    if (!position) {
        return null;
    }
    var _a = position.split("_"), column = _a[1];
    return positionMap[column];
}
function getRow(imageType) {
    var position = INVERSE_IMAGE_TYPES[imageType];
    if (!position) {
        return null;
    }
    var row = position.split("_")[0];
    return positionMap[row];
}
function selectUniqueImages(imageList) {
    var selectedImageMap = new Map();
    return imageList.map(function (image) {
        if (image.type && !selectedImageMap.has(image.type)) {
            selectedImageMap.set(image.type, image);
            return __assign(__assign({}, image), { status: "SELECTED", position: { row: getRow(image.type), column: getColumn(image.type) } });
        }
        return image;
    });
}
var convertCanvasToBlob = function (canvas) {
    return new Promise(function (resolve) {
        if (typeof canvas.msToBlob === "function") {
            resolve(canvas.msToBlob());
        }
        else if (typeof canvas.toBlob === "function") {
            canvas.toBlob(resolve, "image/jpeg");
        }
        else {
            resolve(null);
        }
    });
};
function createTemplateBlob(compositeState) {
    //const { jobState, compositeState } = usePixPhotoProcessorState();
    var canvas = document.createElement("canvas");
    var images = compositeState.imageList.filter(function (image) { return image.status === "SELECTED"; });
    return drawTemplate(canvas, images, compositeState.logo).then(function () {
        return convertCanvasToBlob(canvas);
    });
}
function getImageParams(naturalWidth, naturalHeight) {
    var ratio = naturalHeight / naturalWidth;
    if (ratio > 0.75) {
        return {
            dh: IMAGE_HEIGHT,
            dw: IMAGE_HEIGHT / ratio,
        };
    }
    else {
        return {
            dh: IMAGE_WIDTH * ratio,
            dw: IMAGE_WIDTH,
        };
    }
}
function roundRect(ctx, x, y, width, height, radius, fill, stroke) {
    if (radius === void 0) { radius = 6; }
    if (fill === void 0) { fill = false; }
    if (stroke === void 0) { stroke = false; }
    var newRadius = { tl: radius, tr: radius, br: radius, bl: radius };
    ctx.beginPath();
    ctx.moveTo(x + newRadius.tl, y);
    ctx.lineTo(x + width - newRadius.tr, y);
    ctx.quadraticCurveTo(x + width, y, x + width, y + newRadius.tr);
    ctx.lineTo(x + width, y + height - newRadius.br);
    ctx.quadraticCurveTo(x + width, y + height, x + width - newRadius.br, y + height);
    ctx.lineTo(x + newRadius.bl, y + height);
    ctx.quadraticCurveTo(x, y + height, x, y + height - newRadius.bl);
    ctx.lineTo(x, y + newRadius.tl);
    ctx.quadraticCurveTo(x, y, x + newRadius.tl, y);
    ctx.closePath();
    if (fill) {
        ctx.fill();
    }
    if (stroke) {
        ctx.strokeStyle = "#28D4FF";
        ctx.stroke();
    }
}
function downloadTemplate(compositeState) {
    return new Promise(function (resolve, reject) {
        createTemplateBlob(compositeState).then(function (blob) { return resolve(blob); });
    });
    // createTemplateBlob(compositeState).then((blob) => {
    //   // IE 11
    //   // if (navigator.msSaveBlob) {
    //   //   return navigator.msSaveBlob(blob, "template.jpg");
    //   // } else {
    //   //   const url = URL.createObjectURL(blob);
    //   //   const link = document.createElement("a");
    //   //   link.href = url;
    //   //   link.setAttribute("download", "template.jpg");
    //   //   document.body.appendChild(link);
    //   //   link.click();
    //   //   setTimeout(() => URL.revokeObjectURL(url));
    //   // }
    // });
}
var GUTTER = 18;
var CANVAS_WIDTH = 1280;
var IMAGE_WIDTH = (1280 - 4 * GUTTER) / 3;
var IMAGE_HEIGHT = 0.75 * IMAGE_WIDTH;
var CANVAS_HEIGHT = IMAGE_HEIGHT * 3 + 4 * GUTTER;
function drawTemplate(canvas, imageList, logo) {
    var ctx = canvas.getContext("2d");
    canvas.width = CANVAS_WIDTH;
    canvas.height = CANVAS_HEIGHT;
    if (ctx !== null) {
        ctx.fillStyle = "white";
        ctx.fillRect(0, 0, canvas.width, canvas.height);
        var getX_1 = function (column) {
            if (column === null)
                return 0;
            return GUTTER + (IMAGE_WIDTH + GUTTER) * (column - 1);
        };
        var getY_1 = function (row) {
            if (row === null)
                return 0;
            return GUTTER + (IMAGE_HEIGHT + GUTTER) * (row - 1);
        };
        return imageList
            .reduce(function (prevPromise, image) {
            return prevPromise.then(function () {
                return drawRoundedImage(ctx, image.src, getX_1(image.position.column), getY_1(image.position.row));
            });
        }, Promise.resolve())
            .then(function () {
            if (logo) {
                drawRoundedLogo(ctx, logo, getX_1(2), getY_1(2));
            }
        })
            .then(function () { return canvas; });
    }
    else {
        return new Promise(function () { return canvas; });
    }
}
function getLogoParams(naturalWidth, naturalHeight) {
    var ratio = naturalHeight / naturalWidth;
    if (ratio > 0.75) {
        var dh = naturalHeight > IMAGE_HEIGHT ? IMAGE_HEIGHT : naturalHeight;
        return {
            dh: dh,
            dw: dh / ratio,
        };
    }
    else {
        var dw = naturalWidth > IMAGE_WIDTH ? IMAGE_WIDTH : naturalWidth;
        return {
            dh: dw * ratio,
            dw: dw,
        };
    }
}
function drawLogo(ctx, imageSrc, x, y) {
    return getImageFromSource(imageSrc).then(function (image) {
        var naturalWidth = image.naturalWidth, naturalHeight = image.naturalHeight;
        var _a = getLogoParams(naturalWidth, naturalHeight), dw = _a.dw, dh = _a.dh;
        var dx = x + (IMAGE_WIDTH - dw) / 2;
        var dy = y + (IMAGE_HEIGHT - dh) / 2;
        ctx.drawImage(image, dx, dy, dw, dh);
    });
}
function drawImage(ctx, imageSrc, x, y) {
    return getImageFromSource(imageSrc).then(function (image) {
        var naturalWidth = image.naturalWidth, naturalHeight = image.naturalHeight;
        var _a = getImageParams(naturalWidth, naturalHeight), dw = _a.dw, dh = _a.dh;
        var dx = x + (IMAGE_WIDTH - dw) / 2;
        var dy = y + (IMAGE_HEIGHT - dh) / 2;
        ctx.drawImage(image, dx, dy, dw, dh);
    });
}
var drawRoundedLogo = function (ctx, imageSrc, x, y) {
    ctx.save();
    roundRect(ctx, x, y, IMAGE_WIDTH, IMAGE_HEIGHT, 6, false, true);
    ctx.clip();
    return drawLogo(ctx, imageSrc, x, y).then(function () { return ctx.restore(); });
};
var drawRoundedImage = function (ctx, imageSrc, x, y) {
    ctx.save();
    roundRect(ctx, x, y, IMAGE_WIDTH, IMAGE_HEIGHT, 6, false, true);
    ctx.clip();
    return drawImage(ctx, imageSrc, x, y).then(function () { return ctx.restore(); });
};

var PixPhotoProcessorStateContext = React.createContext(undefined);
var PixPhotoProcessorDispatchContext = React.createContext(undefined);
var defaultJobState = {
    jobProgress: 0,
    jobStatus: exports.JOB_STATUTES.IDLE,
    templateStatus: exports.TEMPLATE_STATUTES.IDLE,
    downloadCounter: 0,
};
var defaultBatchState = {
    compositeState: {
        imageList: [],
        readOnly: false,
        isInitialized: false,
        logo: "",
    },
    jobState: defaultJobState,
    jobId: ""
};
var defaultPhotoProcessorState = {
    step: exports.PhotoProcessorStep.WAITING_FOR_FILES,
    editorState: {
        isOn: false,
    },
    batch: []
};
var importReducer = function (state, action) {
    switch (action.type) {
        case exports.PixPhotoProcessorActionType.CANCEL_EDIT_IMAGES: {
            return __assign(__assign({}, state), { batch: state.batch.map(function (mapJob, i) {
                    if (i === action.batchIndex) {
                        return __assign(__assign({}, mapJob), { compositeState: __assign(__assign({}, mapJob.compositeState), { editingImage: __assign(__assign({}, mapJob.compositeState.editingImage), { src: mapJob.compositeState.editingImage.editorSrc }), imageList: state.batch[action.batchIndex].compositeState.imageList.map(function (image) {
                                    return __assign(__assign({}, image), { editParams: image.initEditParams });
                                }) }) });
                    }
                    return mapJob;
                }) });
        }
        case exports.PixPhotoProcessorActionType.SAVE_EDIT_IMAGES: {
            return __assign(__assign({}, state), { batch: state.batch.map(function (mapJob, i) {
                    if (i === action.batchIndex) {
                        return __assign(__assign({}, mapJob), { compositeState: __assign(__assign({}, mapJob.compositeState), { imageList: state.batch[action.batchIndex].compositeState.imageList.map(function (image) {
                                    if (image.id === action.currentId)
                                        return __assign(__assign({}, image), { initEditParams: action.currentEditParams, editParams: action.currentEditParams, src: action.currentEditSrc });
                                    return __assign(__assign({}, image), { initEditParams: image.editParams });
                                }) }) });
                    }
                    return mapJob;
                }) });
        }
        case exports.PixPhotoProcessorActionType.SWITCH_EDIT_IMAGE: {
            var currentEditingImage_1 = state.batch[action.batchIndex].compositeState.editingImage;
            return __assign(__assign({}, state), { batch: state.batch.map(function (mapJob, i) {
                    if (i === action.batchIndex) {
                        return __assign(__assign({}, mapJob), { compositeState: __assign(__assign({}, mapJob.compositeState), { editingImage: mapJob.compositeState.imageList.find(function (image) { return image.id === action.imageId; }), imageList: state.batch[action.batchIndex].compositeState.imageList.map(function (image) {
                                    if (image.id === currentEditingImage_1.id) {
                                        return __assign(__assign({}, image), { src: action.src, editParams: action.params, editorSrc: action.editorSrc });
                                    }
                                    return image;
                                }) }) });
                    }
                }) });
        }
        case exports.PixPhotoProcessorActionType.CHANGE_SOURCE: {
            return __assign(__assign({}, state), { batch: state.batch.map(function (mapJob, i) {
                    if (i === action.batchIndex) {
                        return __assign(__assign({}, mapJob), { compositeState: __assign(__assign({}, mapJob.compositeState), { editingImage: __assign(__assign({}, mapJob.compositeState.editingImage), { editorSrc: mapJob.compositeState.editingImage.isOriginal ? mapJob.compositeState.editingImage.processedSrc : mapJob.compositeState.editingImage.originalSrc, isOriginal: !mapJob.compositeState.editingImage.isOriginal }), imageList: state.batch[action.batchIndex].compositeState.imageList.map(function (image) {
                                    if (image.id === action.imageId) {
                                        return __assign(__assign({}, image), { editorSrc: image.isOriginal ? image.processedSrc : image.originalSrc, isOriginal: !image.isOriginal });
                                    }
                                    return image;
                                }) }) });
                    }
                    return mapJob;
                }) });
        }
        case exports.PixPhotoProcessorActionType.SET_REDUCER: {
            return __assign(__assign({}, state), { batch: Array(action.len).fill(defaultBatchState) });
        }
        case exports.PixPhotoProcessorActionType.SET_EDITOR_STATE: {
            return __assign(__assign({}, state), { editorState: __assign(__assign({}, state.editorState), { isOn: action.state }) });
        }
        case exports.PixPhotoProcessorActionType.SET_STEP: {
            return __assign(__assign({}, state), { step: action.step });
        }
        case exports.PixPhotoProcessorActionType.SET_PE_PROCESSING: {
            return __assign(__assign({}, state), { step: exports.PhotoProcessorStep.PROCESSING, batch: state.batch.map(function (mapJob, i) {
                    if (i === action.batchIndex) {
                        return __assign(__assign({}, mapJob), { jobId: action.jobId });
                    }
                    return mapJob;
                }) });
        }
        case exports.PixPhotoProcessorActionType.SET_PE_GALLERY: {
            return __assign(__assign({}, state), { step: exports.PhotoProcessorStep.GALLERY, batch: state.batch.map(function (mapJob, i) {
                    if (i === action.batchIndex) {
                        return __assign(__assign({}, mapJob), { jobState: __assign(__assign({}, mapJob.jobState), { job: action.processedJob }) });
                    }
                    return mapJob;
                }) });
        }
        case exports.PixPhotoProcessorActionType.SET_PE_COMPOSITE: {
            return __assign(__assign({}, state), { step: exports.PhotoProcessorStep.COMPOSITE });
        }
        case exports.PixPhotoProcessorActionType.RESET_PHOTO_PROCESSOR: {
            return __assign(__assign({}, state), { batch: state.batch.map(function (mapJob, i) {
                    if (i === action.batchIndex) {
                        return __assign({}, defaultJobState);
                    }
                    return mapJob;
                }) });
        }
        case exports.PixPhotoProcessorActionType.SET_COMPOSITE_INITIALIZED: {
            return __assign(__assign({}, state), { batch: state.batch.map(function (mapJob, i) {
                    if (i === action.batchIndex) {
                        return __assign(__assign({}, mapJob), { compositeState: __assign(__assign({}, state.batch[action.batchIndex].compositeState), { isInitialized: action.isInitialized }) });
                    }
                    return mapJob;
                }) });
        }
        case exports.PixPhotoProcessorActionType.SET_COMPOSITE_IMAGE_LIST: {
            return __assign(__assign({}, state), { batch: state.batch.map(function (mapJob, i) {
                    if (i === action.batchIndex) {
                        return __assign(__assign({}, mapJob), { compositeState: __assign(__assign({}, state.batch[action.batchIndex].compositeState), { imageList: action.imageList }) });
                    }
                    return mapJob;
                }) });
        }
        case exports.PixPhotoProcessorActionType.SET_COMPOSITE_LOADING: {
            return __assign(__assign({}, state), { batch: state.batch.map(function (mapJob, i) {
                    if (i === action.batchIndex) {
                        return __assign(__assign({}, mapJob), { compositeState: __assign(__assign({}, state.batch[action.batchIndex].compositeState), { isLoading: action.isLoading }) });
                    }
                    return mapJob;
                }) });
        }
        case exports.PixPhotoProcessorActionType.SELECT_COMPOSITE_IMAGE: {
            if (state.batch[action.payload.batchIndex].compositeState.readOnly)
                return state;
            return __assign(__assign({}, state), { batch: state.batch.map(function (mapJob, i) {
                    if (i === action.payload.batchIndex) {
                        return __assign(__assign({}, mapJob), { compositeState: __assign(__assign({}, mapJob.compositeState), { imageList: state.batch[action.payload.batchIndex].compositeState.imageList.map(function (image) {
                                    if (image.id === action.payload.imageId) {
                                        return __assign(__assign({}, image), { status: "SELECTED", position: action.payload.position });
                                    }
                                    return image;
                                }) }) });
                    }
                    return mapJob;
                }) });
        }
        case exports.PixPhotoProcessorActionType.UNSELECT_COMPOSITE_IMAGE: {
            if (state.batch[action.batchIndex].compositeState.readOnly)
                return state;
            var imageIndex_1 = state.batch[action.batchIndex].compositeState.imageList.findIndex(function (image) { return image.id === action.imageId; });
            var updatedImage_1 = __assign(__assign({}, state.batch[action.batchIndex].compositeState.imageList[imageIndex_1]), { status: "UNSELECTED", position: { row: -1, column: -1 } });
            return __assign(__assign({}, state), { batch: state.batch.map(function (mapJob, i) {
                    if (i === action.batchIndex) {
                        return __assign(__assign({}, mapJob), { compositeState: __assign(__assign({}, mapJob.compositeState), { imageList: __spreadArrays([updatedImage_1], state.batch[action.batchIndex].compositeState.imageList.slice(0, imageIndex_1), state.batch[action.batchIndex].compositeState.imageList.slice(imageIndex_1 + 1)) }) });
                    }
                    return mapJob;
                }) });
        }
        case exports.PixPhotoProcessorActionType.SET_COMPOSITE_LOGO_SOURCE: {
            return __assign(__assign({}, state), { batch: state.batch.map(function (mapJob, i) {
                    if (i === action.batchIndex) {
                        return __assign(__assign({}, mapJob), { compositeState: __assign(__assign({}, mapJob.compositeState), { logo: action.logoSrc }) });
                    }
                    return mapJob;
                }) });
        }
        case exports.PixPhotoProcessorActionType.REPLACE_COMPOSITE_IMAGE: {
            if (state.batch[action.payload.batchIndex].compositeState.readOnly)
                return state;
            var oldImage_1 = state.batch[action.payload.batchIndex].compositeState.imageList.find(function (image) { return image.id === action.payload.oldImageId; });
            var newImage_1 = state.batch[action.payload.batchIndex].compositeState.imageList.find(function (image) { return image.id === action.payload.newImageId; });
            return __assign(__assign({}, state), { batch: state.batch.map(function (mapJob, i) {
                    if (i === action.payload.batchIndex) {
                        return __assign(__assign({}, mapJob), { compositeState: __assign(__assign({}, mapJob.compositeState), { imageList: mapJob.compositeState.imageList.map(function (image) {
                                    var _a, _b;
                                    if (image.id === (oldImage_1 === null || oldImage_1 === void 0 ? void 0 : oldImage_1.id)) {
                                        return __assign(__assign({}, image), { status: newImage_1 === null || newImage_1 === void 0 ? void 0 : newImage_1.status, position: (_a = newImage_1 === null || newImage_1 === void 0 ? void 0 : newImage_1.position) !== null && _a !== void 0 ? _a : { row: -1, column: -1 } });
                                    }
                                    if (image.id === (newImage_1 === null || newImage_1 === void 0 ? void 0 : newImage_1.id)) {
                                        return __assign(__assign({}, image), { status: oldImage_1 === null || oldImage_1 === void 0 ? void 0 : oldImage_1.status, position: (_b = oldImage_1 === null || oldImage_1 === void 0 ? void 0 : oldImage_1.position) !== null && _b !== void 0 ? _b : { row: -1, column: -1 } });
                                    }
                                    return image;
                                }) }) });
                    }
                    return mapJob;
                }) });
        }
        case exports.PixPhotoProcessorActionType.START_EDIT_IMAGE: {
            console.log("START EDIT IMAGE");
            if (state.batch[action.batchIndex].compositeState.readOnly) {
                console.log("start edit return readonly");
                return state;
            }
            return __assign(__assign({}, state), { editorState: {
                    isOn: true,
                }, batch: state.batch.map(function (mapJob, i) {
                    if (i === action.batchIndex) {
                        return __assign(__assign({}, mapJob), { compositeState: __assign(__assign({}, mapJob.compositeState), { editingImage: mapJob.compositeState.imageList.find(function (image) { return image.id === action.imageId; }) }) });
                    }
                    return mapJob;
                }) });
        }
        case exports.PixPhotoProcessorActionType.FINISH_EDIT_IMAGE: {
            console.log("FINISH EDIT IMAGE");
            if (state.batch[action.payload.batchIndex].compositeState.readOnly) {
                console.log("finish edit image readonly");
                return state;
            }
            return __assign(__assign({}, state), { editorState: {
                    isOn: false,
                }, batch: state.batch.map(function (mapJob, i) {
                    if (i === action.payload.batchIndex) {
                        return __assign(__assign({}, mapJob), { compositeState: __assign(__assign({}, mapJob.compositeState), { editingImage: undefined, imageList: mapJob.compositeState.imageList.map(function (image) {
                                    if (image.id === action.payload.imageId) {
                                        return __assign(__assign({}, image), { src: action.payload.src, editParams: action.payload.params });
                                    }
                                    return image;
                                }) }) });
                    }
                    return mapJob;
                }) });
        }
        case exports.PixPhotoProcessorActionType.CANCEL_EDIT_IMAGE: {
            if (state.batch[action.batchIndex].compositeState.readOnly)
                return state;
            return __assign(__assign({}, state), { editorState: {
                    isOn: false,
                }, batch: state.batch.map(function (mapJob, i) {
                    if (i === action.batchIndex) {
                        return __assign(__assign({}, mapJob), { compositeState: __assign(__assign({}, mapJob.compositeState), { editingImage: undefined }) });
                    }
                    return mapJob;
                }) });
        }
        case exports.PixPhotoProcessorActionType.SET_JOB_STATUT: {
            return __assign(__assign({}, state), { batch: state.batch.map(function (mapJob, i) {
                    if (i === action.payload.batchIndex) {
                        return __assign(__assign({}, mapJob), { jobState: __assign(__assign({}, mapJob.jobState), { jobStatus: action.payload.status, error: action.payload.status === exports.JOB_STATUTES.FAILURE ? { jobId: action.payload.jobId } : undefined }) });
                    }
                    return mapJob;
                }) });
        }
        case exports.PixPhotoProcessorActionType.SET_JOB_PROGRESS: {
            return __assign(__assign({}, state), { batch: state.batch.map(function (mapJob, i) {
                    if (i === action.batchIndex) {
                        return __assign(__assign({}, mapJob), { jobState: __assign(__assign({}, mapJob.jobState), { jobProgress: action.progress }) });
                    }
                    return mapJob;
                }) });
        }
        case exports.PixPhotoProcessorActionType.SET_TEMPLATE_STATUS: {
            return __assign(__assign({}, state), { batch: state.batch.map(function (mapJob, i) {
                    if (i === action.batchIndex) {
                        return __assign(__assign({}, mapJob), { jobState: __assign(__assign({}, mapJob.jobState), { templateStatus: action.status }) });
                    }
                    return mapJob;
                }) });
        }
        case exports.PixPhotoProcessorActionType.TRIGGER_DOWNLOAD: {
            return __assign(__assign({}, state), { batch: state.batch.map(function (mapJob, i) {
                    if (i === action.batchIndex) {
                        return __assign(__assign({}, mapJob), { jobState: __assign(__assign({}, mapJob.jobState), { downloadCounter: mapJob.jobState.downloadCounter + 1 }) });
                    }
                    return mapJob;
                }) });
        }
        case exports.PixPhotoProcessorActionType.RESET_DOWNLOAD_COUNTER: {
            return __assign(__assign({}, state), { batch: state.batch.map(function (mapJob, i) {
                    if (i === action.batchIndex) {
                        return __assign(__assign({}, mapJob), { jobState: __assign(__assign({}, mapJob.jobState), { downloadCounter: defaultJobState.downloadCounter }) });
                    }
                    return mapJob;
                }) });
        }
        case exports.PixPhotoProcessorActionType.UPDATE_PROCESSED_IMAGE_URL: {
            if (!state.batch[action.payload.batchIndex].jobState.job)
                return state;
            return __assign(__assign({}, state), { batch: state.batch.map(function (mapJob, i) {
                    if (i === action.payload.batchIndex && mapJob.jobState.job) {
                        return __assign(__assign({}, mapJob), { jobState: __assign(__assign({}, mapJob.jobState), { job: __assign(__assign({}, mapJob.jobState.job), { processedImages: mapJob.jobState.job.processedImages.map(function (image) {
                                        if (image.id === action.payload.imageId) {
                                            return __assign(__assign({}, image), { editedUrl: action.payload.editedUrl });
                                        }
                                        return image;
                                    }) }) }) });
                    }
                    return mapJob;
                }) });
        }
        case exports.PixPhotoProcessorActionType.UPDATE_TEMPLATE_ZIP_URL: {
            if (!state.batch[action.batchIndex].jobState.job)
                return state;
            return __assign(__assign({}, state), { batch: state.batch.map(function (mapJob, i) {
                    if (i === action.batchIndex && mapJob.jobState.job) {
                        return __assign(__assign({}, mapJob), { jobState: __assign(__assign({}, mapJob.jobState), { job: __assign(__assign({}, mapJob.jobState.job), { urlZip: action.url }) }) });
                    }
                    return mapJob;
                }) });
        }
        case exports.PixPhotoProcessorActionType.SWAP_JOB: {
            return __assign(__assign({}, state), { batch: state.batch.map(function (mapjob, i) {
                    if (mapjob.jobState.job.id === action.payload.oldJobId) {
                        return __assign(__assign({}, mapjob), { jobState: __assign(__assign({}, mapjob.jobState), { job: action.payload.newJob }), jobId: action.payload.newJob.id });
                    }
                    return mapjob;
                }) });
        }
        default: {
            throw new Error("Unhandled action type '" + JSON.stringify(action) + "'");
        }
    }
};
var PixPhotoProcessorProvider = function (_a) {
    var children = _a.children;
    var _b = React.useReducer(importReducer, defaultPhotoProcessorState), state = _b[0], dispatch = _b[1];
    return (React__default['default'].createElement(PixPhotoProcessorStateContext.Provider, { value: state },
        React__default['default'].createElement(PixPhotoProcessorDispatchContext.Provider, { value: dispatch }, children)));
};
var usePixPhotoProcessorState = function () {
    return useSafeContext(PixPhotoProcessorStateContext, "PixPhotoProcessorState");
};
var usePixPhotoProcessorDispatch = function () {
    return useSafeContext(PixPhotoProcessorDispatchContext, "PixPhotoProcessorDispatch");
};
var usePixPhotoProcessorFunctions = function () {
    var dispatch = usePixPhotoProcessorDispatch();
    var setReducer = React.useCallback(function (len) {
        dispatch({
            type: exports.PixPhotoProcessorActionType.SET_REDUCER,
            len: len
        });
    }, []);
    var goToPreviousStep = React.useCallback(function (step) {
        dispatch({
            type: exports.PixPhotoProcessorActionType.SET_STEP,
            step: step,
        });
    }, []);
    var goToProcessImages = React.useCallback(function (payload, batchIndex) {
        dispatch({
            type: exports.PixPhotoProcessorActionType.SET_PE_PROCESSING,
            jobId: payload.processImages.id,
            batchIndex: batchIndex
        });
    }, []);
    var goToGallery = React.useCallback(function (processedJob, batchIndex) {
        dispatch({
            type: exports.PixPhotoProcessorActionType.SET_PE_GALLERY,
            processedJob: processedJob,
            batchIndex: batchIndex
        });
    }, []);
    var goToComposite = React.useCallback(function () {
        dispatch({
            type: exports.PixPhotoProcessorActionType.SET_PE_COMPOSITE,
        });
    }, []);
    var setCompositeData = React.useCallback(function (rawImages, batchIndex) {
        if (typeof rawImages === "undefined")
            return [];
        dispatch({ type: exports.PixPhotoProcessorActionType.SET_COMPOSITE_LOADING, isLoading: true, batchIndex: batchIndex });
        Promise.all(rawImages.map(convertImage).map(addImageParams))
            .then(selectUniqueImages)
            .then(function (imageList) {
            dispatch({ type: exports.PixPhotoProcessorActionType.SET_COMPOSITE_IMAGE_LIST, imageList: imageList, batchIndex: batchIndex });
            dispatch({
                type: exports.PixPhotoProcessorActionType.SET_COMPOSITE_INITIALIZED,
                isInitialized: true,
                batchIndex: batchIndex
            });
            dispatch({ type: exports.PixPhotoProcessorActionType.SET_COMPOSITE_LOADING, isLoading: false, batchIndex: batchIndex });
        })
            .catch(function (error) {
            console.error(error);
            dispatch({ type: exports.PixPhotoProcessorActionType.SET_COMPOSITE_LOADING, isLoading: false, batchIndex: batchIndex });
        });
    }, []);
    var unselectCompositeImage = React.useCallback(function (imageId, batchIndex) {
        dispatch({
            type: exports.PixPhotoProcessorActionType.UNSELECT_COMPOSITE_IMAGE,
            imageId: imageId,
            batchIndex: batchIndex
        });
    }, []);
    var selectCompositeImage = React.useCallback(function (imageId, row, col, batchIndex) {
        dispatch({
            type: exports.PixPhotoProcessorActionType.SELECT_COMPOSITE_IMAGE,
            payload: {
                imageId: imageId,
                position: { row: row, col: col },
                batchIndex: batchIndex
            }
        });
    }, []);
    /**
     * Extremely basic way to handle Errors
     */
    var handleError = React.useCallback(function (step, description, batchIndex) {
        var toast = react.useToast();
        toast({
            position: "top",
            title: "Error in " + step + " step",
            description: description,
            status: "error",
            duration: 9000,
            isClosable: true,
        });
        dispatch({
            type: exports.PixPhotoProcessorActionType.RESET_PHOTO_PROCESSOR,
            batchIndex: batchIndex
        });
    }, []);
    var changeImageSource = React.useCallback(function (batchIndex, imageId) {
        dispatch({
            type: exports.PixPhotoProcessorActionType.CHANGE_SOURCE,
            batchIndex: batchIndex,
            imageId: imageId
        });
    }, []);
    return {
        changeImageSource: changeImageSource,
        setReducer: setReducer,
        goToPreviousStep: goToPreviousStep,
        goToProcessImages: goToProcessImages,
        goToGallery: goToGallery,
        handleError: handleError,
        goToComposite: goToComposite,
        setCompositeData: setCompositeData,
        unselectCompositeImage: unselectCompositeImage,
        selectCompositeImage: selectCompositeImage
    };
};
var usePixPhotoProcessor = function () { return [usePixPhotoProcessorState(), usePixPhotoProcessorDispatch()]; };

function DropBlock(_a) {
    var batchIndex = _a.batchIndex, column = _a.column, row = _a.row;
    usePixPhotoProcessorFunctions().unselectCompositeImage;
    var batch = usePixPhotoProcessorState().batch;
    var dispatch = usePixPhotoProcessorDispatch();
    var _b = batch[batchIndex].compositeState, imageList = _b.imageList, readOnly = _b.readOnly;
    var image = React.useMemo(function () {
        return imageList.find(function (image) {
            var _a, _b;
            return image.status === "SELECTED" &&
                ((_a = image.position) === null || _a === void 0 ? void 0 : _a.row) === row &&
                ((_b = image.position) === null || _b === void 0 ? void 0 : _b.column) === column;
        });
    }, [row, column, imageList]);
    var _c = reactDnd.useDrop({
        accept: "photo",
        drop: function (item) {
            if (!image) {
                dispatch({
                    type: exports.PixPhotoProcessorActionType.SELECT_COMPOSITE_IMAGE,
                    payload: { imageId: item.image.id, position: { row: row, column: column }, batchIndex: batchIndex },
                });
            }
            else {
                dispatch({
                    type: exports.PixPhotoProcessorActionType.REPLACE_COMPOSITE_IMAGE,
                    payload: { oldImageId: image.id, newImageId: item.image.id, batchIndex: batchIndex },
                });
            }
            return { success: true };
        },
        canDrop: function (dragItem) { return !image || (image && dragItem.image.id !== image.id); },
        collect: function (monitor) { return ({
            isOver: !!monitor.isOver(),
            canDrop: !!monitor.canDrop(),
        }); },
    }), _d = _c[0]; _d.canDrop; _d.isOver; var dropTargetRef = _c[1];
    var _e = reactDnd.useDrag({
        item: { name: "Photo", type: "photo", image: image },
        options: {
            dropEffect: "copy",
        },
        collect: function (monitor) { return ({
            isDragging: monitor.isDragging(),
        }); },
        canDrag: !readOnly,
    }), isDragging = _e[0].isDragging, dragTargetRef = _e[1];
    var opacity = isDragging ? 0.4 : 1;
    return (React__default['default'].createElement(react.Box, { h: "215.75px", bg: "white", width: "287px", borderRadius: "5px", boxShadow: "0px 4px 10px rgba(0, 0, 0, 0.1)", opacity: opacity, ref: dropTargetRef }, image ? (React__default['default'].createElement(react.Box, { h: "100%", ref: dragTargetRef },
        React__default['default'].createElement(react.Image, { height: "100%", width: "100%", objectFit: "cover", src: image.src, crossOrigin: "anonymous" }))) : (React__default['default'].createElement(react.Box, { h: "100%" }))));
}

/* import { getImageFromSource } from './utils';

interface Frame {
  height: number;
  width: number;
}

export interface Canvas extends HTMLCanvasElement {
  centerX: number;
  centerY: number;
}

interface CacheCanvas {
  width: number;
  height: number;
  centerX: number;
  centerY: number;
}

const RADIUS = Math.PI / 180;

const cache = {
  canvas: {
    width: 0,
    height: 0,
    centerX: 0,
    centerY: 0,
  },
  view: {
    width: 0,
    height: 0,
    centerX: 0,
    centerY: 0,
  },
  img: {
    width: 0,
    height: 0,
    centerX: 0,
    centerY: 0,
  },
};

interface CanvasEditorParams {
  scale: number;
  rotate: number;
  translate: {
    x: number;
    y: number;
  };
}

export class CanvasEditor {
  canvas: Canvas;
  ctx: CanvasRenderingContext2D | undefined | null;
  img: HTMLImageElement | undefined;
  scale: number;
  rotate: number;
  translate: {
    x: number;
    y: number;
  };

  constructor(canvasElem: Canvas, params: CanvasEditorParams) {
    console.log("constructor:", canvasElem, params)
    this.canvas = canvasElem;
    this.ctx = undefined;
    this.img = undefined;
    this.scale = params.scale;
    this.rotate = params.rotate;
    this.translate = params.translate;
  }

  onScale(value: number) {
    this.scale = value;
    this.drawSceneAsAnimationFrame();
  }

  calculateScaleOnRotate() {
    const { view } = cache;

    let absAngle = this.rotate > 180 ? 360 - this.rotate : this.rotate;

    if (absAngle > 90 && absAngle <= 180) {
      absAngle = 180 - absAngle;
    }

    const alpha = (absAngle * Math.PI) / 180;

    return Math.max(
      Math.cos(alpha) + (Math.sin(alpha) * view.width) / view.height,
      Math.cos(alpha) + (Math.sin(alpha) * view.height) / view.width
    );
  }

  getEditParams() {
    return {
      translate: this.translate,
      scale: this.scale,
      rotate: this.rotate,
    };
  }

  onRotate(value: number) {
    this.rotate = value;
    this.scale = this.calculateScaleOnRotate();

    this.drawSceneAsAnimationFrame();
  }

  onTranslate(deltaX: number, deltaY: number) {
    this.translate = { x: this.translate.x + deltaX, y: this.translate.y + deltaY };
    this.drawSceneAsAnimationFrame();
  }

  setTransform(params: CanvasEditorParams) {
    this.scale = params.scale;
    this.rotate = params.rotate;
    this.translate = params.translate;
    this.drawSceneAsAnimationFrame();
  }

  drawScene(options = { withBackground: false }) {
    const { canvas, img, view } = cache;

    this.resetCanvas(canvas);

    if (options.withBackground) {
      if (typeof this.ctx !== "undefined" && this.ctx) {
        this.ctx.fillStyle = "white";
        this.ctx?.fillRect(
          (canvas.width - view.width) / 2 - 1,
          (canvas.height - view.height) / 2 - 1,
          view.width + 2,
          view.height + 2
        );
      }
    }

    this.saveContext();
    if (typeof this.ctx !== "undefined" && this.ctx) {
      this.ctx.translate(canvas.centerX + this.translate.x, canvas.centerY + this.translate.y);
      this.ctx.scale(this.scale - 0.1, this.scale);
      this.ctx.rotate(this.rotate * RADIUS);
    }

    const { width, height } = img;
    if (typeof this.ctx !== "undefined" && this.ctx) {
      if (typeof this.img !== "undefined") {
        this.ctx.drawImage(this.img, -width / 2, -height / 2, width, height);
      }
    }
    this.restoreContext();
    this.saveContext();

    if (!options.withBackground) {
      this.createMask(canvas);
    }
    this.restoreContext();
  }

  drawSceneAsAnimationFrame() {
    window.requestAnimationFrame(() => {
      this.drawScene();
    });
  }

  saveContext() {
    if (typeof this.ctx !== "undefined" && this.ctx) {
      this.ctx.save();
    }
  }

  restoreContext() {
    if (typeof this.ctx !== "undefined" && this.ctx) {
      this.ctx.restore();
    }
  }

  initImage(src: string, frame: Frame) {
    getImageFromSource(src).then((image) => {
      this.img = image;
      this.setViewCoords(frame);
      this.setImgCords();
      this.initCanvas();
      this.drawSceneAsAnimationFrame();
    });
  }

  getImageParams(naturalWidth: number, naturalHeight: number) {
    const { view } = cache;
    const ratio = naturalHeight / naturalWidth;

    if (ratio > 0.75) {
      return {
        dh: view.height,
        dw: view.height / ratio,
      };
    } else {
      return {
        dh: view.width * ratio,
        dw: view.width,
      };
    }
  }

  setImgCords() {
    if (typeof this.img === "undefined") return;
    const { dh, dw } = this.getImageParams(this.img?.naturalWidth, this.img?.naturalHeight);
    const mdh = dh + 310;
    cache.img.width = dw;
    cache.img.height = mdh;
    cache.img.centerX = dw / 2;
    cache.img.centerY = mdh / 2;
  }

  setViewCoords(frame: Frame) {
    const width = frame.width;//(frame.width * 2) - 20;
    const height = frame.height + 310;//(frame.height * 2) + 50;
    cache.view.width = width;
    cache.view.height = height;
    cache.view.centerX = width / 2;
    cache.view.centerY = height / 2;
  }

  initCanvas() {
    this.ctx = this.canvas.getContext("2d");
    this.setCanvasSize();
  }

  setCanvasSize() {
    const { width, height } = CanvasEditor.getViewportSize();
    this.canvas.width = cache.canvas.width = width;
    this.canvas.height = cache.canvas.height = height;
    cache.canvas.centerX = width / 2;
    cache.canvas.centerY = height / 2;
  }

  resetCanvas(canvas: CacheCanvas) {
    if (typeof this.ctx !== "undefined" && this.ctx) {
      this.ctx.clearRect(0, 0, canvas.width, canvas.height);
    }
  }

  createMask(canvas: CacheCanvas) {
    const { view } = cache;

    if (typeof this.ctx !== "undefined" && this.ctx) {
      this.ctx.beginPath();
      this.ctx.moveTo(0, 0);
      this.ctx.lineTo(canvas.width, 0);
      this.ctx.lineTo(canvas.width, canvas.height);
      this.ctx.lineTo(0, canvas.height);
      this.ctx.lineTo(0, 0);
      this.ctx.closePath();

      this.ctx.translate(canvas.centerX, canvas.centerY);

      this.ctx.moveTo(view.centerX, view.centerY);
      this.ctx.lineTo(view.centerX, view.centerY - view.height);
      this.ctx.lineTo(view.centerX - view.width, view.centerY - view.height);
      this.ctx.lineTo(view.centerX - view.width, view.centerY);
      this.ctx.lineTo(view.centerX, view.centerY);
      this.ctx.closePath();

      this.ctx.fillStyle = "rgba(247, 247, 247, .8)";
      this.ctx.fill();
    }
  }

  getEditedImageSrc() {
    const { canvas, view } = cache;
    this.drawScene({ withBackground: true });

    const viewData = this.ctx?.getImageData(
      canvas.centerX - view.centerX,
      canvas.centerY - view.centerY,
      view.width,
      view.height
    );
    const newCanvas = document.createElement("canvas");
    newCanvas.width = view.width;
    newCanvas.height = view.height;
    const newCtx = newCanvas.getContext("2d");
    if (typeof viewData !== "undefined") {
      newCtx?.putImageData(viewData, 0, 0);
    }

    return { src: newCanvas.toDataURL("image/jpeg"), canvas: newCanvas };
  }

  static getViewportSize() {
    const maxViewWidth = Math.max(window.innerWidth, cache.img.width);
    const maxViewHeight = Math.max(window.innerHeight, cache.img.height);

    return {
      width: maxViewWidth,
      height: maxViewHeight,
    };
  }
}
 */
var RADIUS = Math.PI / 180;
var cache = {
    canvas: {
        width: 0,
        height: 0,
        centerX: 0,
        centerY: 0,
    },
    view: {
        width: 0,
        height: 0,
        centerX: 0,
        centerY: 0,
    },
    img: {
        width: 0,
        height: 0,
        centerX: 0,
        centerY: 0,
    },
};
var CanvasEditor = /** @class */ (function () {
    function CanvasEditor(canvasElem, params) {
        this.canvas = canvasElem;
        this.ctx = undefined;
        this.img = undefined;
        this.scale = params.scale;
        this.rotate = params.rotate;
        this.translate = params.translate;
    }
    CanvasEditor.prototype.onScale = function (value) {
        this.scale = value;
        this.drawSceneAsAnimationFrame();
    };
    /** Source: https://math.stackexchange.com/a/2774481 */
    CanvasEditor.prototype.calculateScaleOnRotate = function () {
        var view = cache.view;
        var absAngle = this.rotate > 180 ? 360 - this.rotate : this.rotate;
        if (absAngle > 90 && absAngle <= 180) {
            absAngle = 180 - absAngle;
        }
        var alpha = (absAngle * Math.PI) / 180;
        return Math.max(Math.cos(alpha) + (Math.sin(alpha) * view.width) / view.height, Math.cos(alpha) + (Math.sin(alpha) * view.height) / view.width);
    };
    CanvasEditor.prototype.getEditParams = function () {
        return {
            translate: this.translate,
            scale: this.scale,
            rotate: this.rotate,
        };
    };
    CanvasEditor.prototype.onRotate = function (value) {
        this.rotate = value;
        this.scale = this.calculateScaleOnRotate();
        this.drawSceneAsAnimationFrame();
    };
    CanvasEditor.prototype.onTranslate = function (deltaX, deltaY) {
        this.translate = { x: this.translate.x + deltaX, y: this.translate.y + deltaY };
        this.drawSceneAsAnimationFrame();
    };
    CanvasEditor.prototype.setTransform = function (params) {
        this.scale = params.scale;
        this.rotate = params.rotate;
        this.translate = params.translate;
        this.drawSceneAsAnimationFrame();
    };
    CanvasEditor.prototype.drawScene = function (options) {
        var _a;
        if (options === void 0) { options = { withBackground: false }; }
        var canvas = cache.canvas, img = cache.img, view = cache.view;
        this.resetCanvas(canvas);
        if (options.withBackground) {
            /** we add 1px from each side to avoid black borders on final template */
            if (typeof this.ctx !== "undefined" && this.ctx) {
                this.ctx.fillStyle = "white";
                (_a = this.ctx) === null || _a === void 0 ? void 0 : _a.fillRect((canvas.width - view.width) / 2 - 1, (canvas.height - view.height) / 2 - 1, view.width + 2, view.height + 2);
            }
        }
        this.saveContext();
        if (typeof this.ctx !== "undefined" && this.ctx) {
            this.ctx.translate(canvas.centerX + this.translate.x, canvas.centerY + this.translate.y);
            this.ctx.scale(this.scale, this.scale);
            this.ctx.rotate(this.rotate * RADIUS);
        }
        var width = img.width, height = img.height;
        if (typeof this.ctx !== "undefined" && this.ctx) {
            if (typeof this.img !== "undefined") {
                this.ctx.drawImage(this.img, -width / 2, -height / 2, width, height);
            }
        }
        this.restoreContext();
        this.saveContext();
        if (!options.withBackground) {
            this.createMask(canvas);
        }
        this.restoreContext();
    };
    CanvasEditor.prototype.drawSceneAsAnimationFrame = function () {
        var _this = this;
        window.requestAnimationFrame(function () {
            _this.drawScene();
        });
    };
    CanvasEditor.prototype.saveContext = function () {
        if (typeof this.ctx !== "undefined" && this.ctx) {
            this.ctx.save();
        }
    };
    CanvasEditor.prototype.restoreContext = function () {
        if (typeof this.ctx !== "undefined" && this.ctx) {
            this.ctx.restore();
        }
    };
    CanvasEditor.prototype.initImage = function (src, frame) {
        var _this = this;
        getImageFromSource(src).then(function (image) {
            _this.img = image;
            _this.setViewCoords(frame);
            _this.setImgCords();
            _this.initCanvas();
            _this.drawSceneAsAnimationFrame();
        });
    };
    CanvasEditor.prototype.getImageParams = function (naturalWidth, naturalHeight) {
        var view = cache.view;
        var ratio = naturalHeight / naturalWidth;
        if (ratio > 0.75) {
            return {
                dh: view.height,
                dw: view.height / ratio,
            };
        }
        else {
            return {
                dh: view.width * ratio,
                dw: view.width,
            };
        }
    };
    CanvasEditor.prototype.setImgCords = function () {
        var _a, _b;
        if (typeof this.img === "undefined")
            return;
        var _c = this.getImageParams((_a = this.img) === null || _a === void 0 ? void 0 : _a.naturalWidth, (_b = this.img) === null || _b === void 0 ? void 0 : _b.naturalHeight), dh = _c.dh, dw = _c.dw;
        cache.img.width = dw;
        cache.img.height = dh;
        cache.img.centerX = dw / 2;
        cache.img.centerY = dh / 2;
    };
    CanvasEditor.prototype.setViewCoords = function (frame) {
        cache.view.width = frame.width;
        cache.view.height = frame.height;
        cache.view.centerX = frame.width / 2;
        cache.view.centerY = frame.height / 2;
    };
    CanvasEditor.prototype.initCanvas = function () {
        this.ctx = this.canvas.getContext("2d");
        this.setCanvasSize();
    };
    CanvasEditor.prototype.setCanvasSize = function () {
        var _a = CanvasEditor.getViewportSize(), width = _a.width, height = _a.height;
        this.canvas.width = cache.canvas.width = width;
        this.canvas.height = cache.canvas.height = height;
        cache.canvas.centerX = width / 2;
        cache.canvas.centerY = height / 2;
    };
    CanvasEditor.prototype.resetCanvas = function (canvas) {
        if (typeof this.ctx !== "undefined" && this.ctx) {
            this.ctx.clearRect(0, 0, canvas.width, canvas.height);
        }
    };
    CanvasEditor.prototype.createMask = function (canvas) {
        var view = cache.view;
        if (typeof this.ctx !== "undefined" && this.ctx) {
            this.ctx.beginPath();
            this.ctx.moveTo(0, 0);
            this.ctx.lineTo(canvas.width, 0);
            this.ctx.lineTo(canvas.width, canvas.height);
            this.ctx.lineTo(0, canvas.height);
            this.ctx.lineTo(0, 0);
            this.ctx.closePath();
            this.ctx.translate(canvas.centerX, canvas.centerY);
            this.ctx.moveTo(view.centerX, view.centerY);
            this.ctx.lineTo(view.centerX, view.centerY - view.height);
            this.ctx.lineTo(view.centerX - view.width, view.centerY - view.height);
            this.ctx.lineTo(view.centerX - view.width, view.centerY);
            this.ctx.lineTo(view.centerX, view.centerY);
            this.ctx.closePath();
            this.ctx.fillStyle = "rgba(247, 247, 247, .8)";
            this.ctx.fill();
        }
    };
    CanvasEditor.prototype.getEditedImageSrc = function () {
        var _a;
        var canvas = cache.canvas, view = cache.view;
        this.drawScene({ withBackground: true });
        var viewData = (_a = this.ctx) === null || _a === void 0 ? void 0 : _a.getImageData(canvas.centerX - view.centerX, canvas.centerY - view.centerY, view.width, view.height);
        var newCanvas = document.createElement("canvas");
        newCanvas.width = view.width;
        newCanvas.height = view.height;
        var newCtx = newCanvas.getContext("2d");
        if (typeof viewData !== "undefined") {
            newCtx === null || newCtx === void 0 ? void 0 : newCtx.putImageData(viewData, 0, 0);
        }
        return { src: newCanvas.toDataURL("image/jpeg"), canvas: newCanvas };
    };
    CanvasEditor.getViewportSize = function () {
        var maxViewWidth = Math.max(window.innerWidth, cache.img.width);
        var maxViewHeight = Math.max(window.innerHeight, cache.img.height);
        return {
            width: maxViewWidth,
            height: maxViewHeight,
        };
    };
    return CanvasEditor;
}());

var initParams = {
    scale: 1,
    rotate: 0,
    translate: { x: 0, y: 0 },
};
var Editor = function (_a) {
    var children = _a.children, batchIndex = _a.batchIndex;
    var batch = usePixPhotoProcessorState().batch;
    var image = batch[batchIndex].compositeState.editingImage; // Editor step should not be called with editingImage undefined
    var frame = { height: image.naturalHeight, width: image.naturalWidth }; //getFrameParams(image.aspectRatio);
    var isMouseDown = React.useRef(false);
    var previousMovePoint = React.useRef(null);
    var editParams = image.editParams || { scale: 0, rotate: 0, translate: { x: 0, y: 0 } };
    var _b = React.useState(image.editParams ? editParams.scale : initParams.scale), scale = _b[0], setScale = _b[1];
    var _c = React.useState(image.editParams ? editParams.rotate : initParams.rotate), rotate = _c[0], setRotate = _c[1];
    var _d = React.useState(image.editorSrc), editorImageSrc = _d[0], setEditorImageSrc = _d[1];
    var isTranslateDisabled = scale === 1;
    var canvasRef = React.useRef(null);
    var canvasEditor = React.useRef(null);
    React.useLayoutEffect(function () {
        var canvas = canvasRef.current;
        if (canvas) {
            var editor = new CanvasEditor(canvas, {
                rotate: rotate,
                scale: scale,
                translate: editParams.translate || initParams.translate,
            });
            editor.initImage(image.editorSrc, frame);
            canvasEditor.current = editor;
        }
    }, []);
    React.useEffect(function () {
        var handleMouseMove = function (event) {
            var _a;
            if (!isMouseDown.current || isTranslateDisabled)
                return;
            if (previousMovePoint && previousMovePoint.current !== null) {
                (_a = canvasEditor.current) === null || _a === void 0 ? void 0 : _a.onTranslate(event.screenX - previousMovePoint.current.screenX, event.screenY - previousMovePoint.current.screenY);
            }
            previousMovePoint.current = { screenX: event.screenX, screenY: event.screenY };
        };
        document.addEventListener("mousemove", function () { return handleMouseMove; });
        return function () { return document.removeEventListener("mousemove", function () { return handleMouseMove; }); };
    }, [isTranslateDisabled]);
    React.useEffect(function () {
        var handleMoveFinish = function () {
            if (isTranslateDisabled)
                return;
            isMouseDown.current = false;
            previousMovePoint.current = null;
        };
        document.addEventListener("mouseup", handleMoveFinish);
        return function () { return document.removeEventListener("mouseup", handleMoveFinish); };
    }, [isTranslateDisabled]);
    var handleScaleChange = function (value) {
        var _a, _b;
        var newScale = value / 100;
        (_a = canvasEditor.current) === null || _a === void 0 ? void 0 : _a.onScale(newScale);
        var editorParams = (_b = canvasEditor.current) === null || _b === void 0 ? void 0 : _b.getEditParams();
        if (editorParams && editParams.scale) {
            setScale(editorParams.scale);
        }
    };
    var fixAngle = function (value) {
        if (value >= 360)
            return value - 360;
        if (value < 0)
            return 360 + value;
        return value;
    };
    var handleRotate = function (delta) {
        var _a, _b;
        var newRotate = fixAngle(rotate + delta);
        (_a = canvasEditor.current) === null || _a === void 0 ? void 0 : _a.onRotate(newRotate);
        var editorParams = (_b = canvasEditor.current) === null || _b === void 0 ? void 0 : _b.getEditParams();
        if (editorParams) {
            setScale(editorParams.scale);
            setRotate(editorParams.rotate);
        }
    };
    var backToOriginalImage = function () {
        var editor = canvasEditor.current;
        setScale(initParams.scale);
        setRotate(initParams.rotate);
        editor === null || editor === void 0 ? void 0 : editor.setTransform(initParams);
        editor === null || editor === void 0 ? void 0 : editor.initImage(image.originalSrc || "", frame);
        setEditorImageSrc(image.originalSrc || "");
    };
    var backToPixImage = function () {
        var editor = canvasEditor.current;
        setScale(initParams.scale);
        setRotate(initParams.rotate);
        editor === null || editor === void 0 ? void 0 : editor.setTransform(initParams);
        editor === null || editor === void 0 ? void 0 : editor.initImage(image.processedSrc, frame);
        setEditorImageSrc(image.processedSrc);
    };
    var handleMoveStart = function (event) {
        if (isTranslateDisabled || isMouseDown.current)
            return;
        isMouseDown.current = true;
        if (previousMovePoint.current) {
            previousMovePoint.current = { screenX: event.screenX, screenY: event.screenY };
        }
    };
    return (React__default['default'].createElement(react.Box, null, React__default['default'].cloneElement(children, { backToOriginalImage: backToOriginalImage, backToPixImage: backToPixImage, editorImageSrc: editorImageSrc, canvasEditor: canvasEditor, handleRotate: handleRotate, rotate: rotate, frame: frame, scale: scale, handleScaleChange: handleScaleChange, isTranslateDisabled: isTranslateDisabled, handleMoveStart: handleMoveStart, canvasRef: canvasRef, batchIndex: batchIndex })));
};

function AngleItem(_a) {
    var isActive = _a.isActive, angle = _a.angle, index = _a.index;
    return (React__default['default'].createElement(react.Text, { key: index, as: "span", display: "block", width: "50%", position: "absolute", textAlign: "right", color: isActive ? "#28D4FF" : "#0C404D", transformOrigin: "0 0", left: "50%", top: "50%", fontSize: "12px", fontWeight: "600", userSelect: "none", transform: "rotate(" + index + "deg)", __css: {
            "> span": {
                marginLeft: 2,
            },
        } },
        index % 5 === 0 ? angle : null,
        " ",
        index % 5 === 0 ? React__default['default'].createElement("span", null, "\u2022") : React__default['default'].createElement("span", null, "\u2027")));
}
var MemoizedAngleItem = React__default['default'].memo(AngleItem);
function RotationWheel(_a) {
    var _b = _a.value, angle = _b === void 0 ? 0 : _b, onChange = _a.onChange, frame = _a.frame;
    var ref = React.useRef(null);
    var _c = React.useState(false), isMouseDown = _c[0], setMouseDown = _c[1];
    var previousMovePoint = React.useRef(null);
    React.useEffect(function () {
        var _a;
        function listener(event) {
            var deltaAngle = Math.sign(event.deltaY);
            onChange(deltaAngle);
        }
        (_a = ref.current) === null || _a === void 0 ? void 0 : _a.addEventListener("wheel", listener);
        return function () { var _a; return (_a = ref.current) === null || _a === void 0 ? void 0 : _a.removeEventListener("wheel", listener); };
    }, [onChange, angle]);
    React.useEffect(function () {
        function handleMouseMove(event) {
            var _a, _b, _c, _d;
            if (!isMouseDown)
                return;
            var deltaY = event.screenY;
            if ((_a = previousMovePoint.current) === null || _a === void 0 ? void 0 : _a.screenY) {
                deltaY -= (_b = previousMovePoint.current) === null || _b === void 0 ? void 0 : _b.screenY;
            }
            if (Math.abs(deltaY) > 7) {
                if ((_c = previousMovePoint.current) === null || _c === void 0 ? void 0 : _c.screenY) {
                    onChange(Math.sign(event.screenY - ((_d = previousMovePoint.current) === null || _d === void 0 ? void 0 : _d.screenY)));
                    previousMovePoint.current = { screenY: event.screenY };
                }
            }
        }
        document.addEventListener("mousemove", handleMouseMove);
        return function () { return document.removeEventListener("mousemove", handleMouseMove); };
    }, [isMouseDown, onChange]);
    React.useEffect(function () {
        function handleMoveFinish() {
            if (!isMouseDown)
                return;
            setMouseDown(false);
            previousMovePoint.current = null;
        }
        document.addEventListener("mouseup", handleMoveFinish);
        return function () { return document.removeEventListener("mouseup", handleMoveFinish); };
    }, [isMouseDown]);
    function getAngleByIndex(index) {
        if (index === 0)
            return 0;
        return 360 - index;
    }
    function handleMoveStart(event) {
        setMouseDown(true);
        previousMovePoint.current = { screenY: event.screenY };
    }
    return (React__default['default'].createElement(react.Box, { position: "absolute", width: "105px", left: "100%", overflow: "hidden", height: "100%", zIndex: "1", cursor: isMouseDown ? "grabbing" : "grab", onMouseDown: handleMoveStart },
        React__default['default'].createElement(react.Box, { position: "absolute", right: "15px", w: frame.height, h: frame.height },
            React__default['default'].createElement(react.Box, { height: "100%", right: "-7px", ref: ref, transform: "rotate(" + angle + "deg)" }, Array.from({ length: 360 }).map(function (v, index) { return (React__default['default'].createElement(MemoizedAngleItem, { key: getAngleByIndex(index), isActive: getAngleByIndex(index) === angle, angle: getAngleByIndex(index), index: index })); })),
            React__default['default'].createElement(react.Icon, { position: "absolute", right: "-5px", top: "50%", transform: "translate(100%, -50%) translateY(6px) rotate(180deg)", display: "block", width: "0", height: "0", borderTop: "5px solid transparent", borderBottom: "5px solid transparent", borderLeft: "7px solid #28D4FF" }))));
}

var MIN = 100;
var MAX = 400;
var STEP = 1;
function ScaleRange(_a) {
    var value = _a.value, onChange = _a.onChange;
    var _b = React.useState([value]), scaleValue = _b[0], setScaleValue = _b[1];
    React.useEffect(function () {
        setScaleValue([value]);
    }, [value]);
    return (React__default['default'].createElement(react.Stack, { position: "absolute", top: "0", bottom: "0", right: "100%", marginRight: "25px", justify: "space-around", align: "center", bgColor: "white", borderRadius: "8px", w: "68px", border: "2px solid #0C404D" },
        React__default['default'].createElement(react.Text, { fontWeight: "bold", fontSize: "12px", lineHeight: "20px", textTransform: "uppercase", color: "rgba(0,0,0,0.5)" },
            MAX,
            "%"),
        React__default['default'].createElement(reactRange.Range, { step: STEP, min: MIN, max: MAX, direction: reactRange.Direction.Up, onChange: function (values) {
                setScaleValue(values);
                onChange(values[0]);
            }, values: scaleValue, renderTrack: function (_a) {
                var props = _a.props, children = _a.children;
                return (
                // eslint-disable-next-line jsx-a11y/no-static-element-interactions
                React__default['default'].createElement("div", { onMouseDown: props.onMouseDown, onTouchStart: props.onTouchStart, style: __assign(__assign({}, props.style), { height: "465px", display: "flex", width: "4px" }) },
                    React__default['default'].createElement("div", { ref: props.ref, style: {
                            height: "100%",
                            width: "100%",
                            borderRadius: "4px",
                            background: reactRange.getTrackBackground({
                                values: scaleValue,
                                direction: reactRange.Direction.Up,
                                colors: ["#28D4FF", "#AFAFAF"],
                                min: MIN,
                                max: MAX,
                            }),
                            alignSelf: "center",
                        } }, children)));
            }, renderThumb: function (_a) {
                var props = _a.props;
                return (React__default['default'].createElement("div", __assign({}, props, { style: __assign(__assign({}, props.style), { height: "20px", width: "20px", borderRadius: "50%", backgroundColor: "#FFF", display: "flex", justifyContent: "center", alignItems: "center", boxShadow: "0px 4px 4px rgba(0, 0, 0, 0.25)" }) }),
                    React__default['default'].createElement("div", { style: {
                            position: "absolute",
                            left: "-70px",
                            color: "#28D4FF",
                            fontWeight: "bold",
                            fontSize: "14px",
                            padding: "8px",
                            borderRadius: "4px",
                            backgroundColor: "white",
                        } }, Math.round(scaleValue[0])),
                    React__default['default'].createElement("div", { style: {
                            height: "4px",
                            width: "4px",
                            backgroundColor: "#28D4FF",
                        } })));
            } }),
        React__default['default'].createElement(react.Text, { fontWeight: "bold", fontSize: "12px", lineHeight: "20px", textTransform: "uppercase", color: "rgba(0,0,0,0.5)" },
            MIN,
            "%")));
}

exports.CanvasEditor = CanvasEditor;
exports.DropBlock = DropBlock;
exports.Editor = Editor;
exports.PixPhotoProcessorProvider = PixPhotoProcessorProvider;
exports.RotationWheel = RotationWheel;
exports.ScaleRange = ScaleRange;
exports.downloadTemplate = downloadTemplate;
exports.generateTemplateData = generateTemplateData;
exports.usePixPhotoProcessor = usePixPhotoProcessor;
exports.usePixPhotoProcessorDispatch = usePixPhotoProcessorDispatch;
exports.usePixPhotoProcessorFunctions = usePixPhotoProcessorFunctions;
exports.usePixPhotoProcessorState = usePixPhotoProcessorState;
//# sourceMappingURL=index.cjs.js.map
