import { CompositeImage, Job, TemplateImage } from './types';
export interface CustomCanvas extends HTMLCanvasElement {
    msToBlob?: () => void;
}
export declare const generateTemplateData: (jobData: Job) => TemplateImage[];
export declare function getImageFromSource(source: string): Promise<HTMLImageElement>;
export declare function addImageParams(imageObject: CompositeImage): Promise<{
    naturalWidth: number;
    naturalHeight: number;
    aspectRatio: number;
    id: string;
    type: import("./types").ImageTypeEnum;
    status?: string;
    src: string;
    filename: string;
    editorSrc: string;
    processedSrc: string;
    originalSrc?: string;
    editParams?: import("./types").EditParams;
    initEditParams?: import("./types").EditParams;
    position: import("./types").Position;
    isOriginal: boolean;
}>;
export declare function convertImage(image: TemplateImage): CompositeImage;
export declare function selectUniqueImages(imageList: CompositeImage[]): CompositeImage[];
export declare function getImageParams(naturalWidth: number, naturalHeight: number): {
    dh: number;
    dw: number;
};
export declare function downloadTemplate(compositeState: any): Promise<unknown>;
export declare const IMAGE_WIDTH: number;
export declare const IMAGE_HEIGHT: number;
export declare function drawTemplate(canvas: HTMLCanvasElement, imageList: CompositeImage[], logo: string): Promise<unknown>;
export declare function getLogoParams(naturalWidth: number, naturalHeight: number): {
    dh: number;
    dw: number;
};
