import babel from '@rollup/plugin-babel';
import del from 'rollup-plugin-delete';
import external from 'rollup-plugin-peer-deps-external';
import typescript from 'rollup-plugin-typescript2';

import pkg from './package.json';

export default {
    input: 'src/index.ts',
    output: [
        {
            file: pkg.main,
            format: 'cjs',
            exports: 'named',
            sourcemap: true,
            strict: false
        }
    ],
    plugins: [
        typescript({ objectHashIgnoreUnknownHack: true })
    ],
    external: ['react', 'react-dom']
};